package blusunrize.immersiveengineering.common.blocks.multiblocks;

import blusunrize.immersiveengineering.api.MultiblockHandler.IMultiblock;
import blusunrize.immersiveengineering.api.crafting.IngredientStack;
import blusunrize.immersiveengineering.common.IEContent;
import blusunrize.immersiveengineering.common.blocks.stone.BlockTypes_StoneDecoration;
import blusunrize.immersiveengineering.common.blocks.stone.BlockTypes_StoneDevices;
import blusunrize.immersiveengineering.common.blocks.stone.TileEntityAlloySmelter;
import blusunrize.immersiveengineering.common.util.Utils;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class MultiblockAlloySmelter implements IMultiblock
{
	public static MultiblockAlloySmelter instance = new MultiblockAlloySmelter();

	static ItemStack[][][] structure = new ItemStack[3][3][3];
	static{
		for(int h=0;h<2;h++)
			for(int l=0;l<2;l++)
				for(int w=0;w<2;w++)
					structure[h][l][w]=new ItemStack(IEContent.blockStoneDecoration,1,BlockTypes_StoneDecoration.ALLOYBRICK.getMeta());
	}
	@Override
	public ItemStack[][][] getStructureManual()
	{
		return structure;
	}
	@Override
	@SideOnly(Side.CLIENT)
	public boolean overwriteBlockRender(ItemStack stack, int iterator)
	{
		return false;
	}
	@Override
	public float getManualScale()
	{
		return 20;
	}
	@Override
	@SideOnly(Side.CLIENT)
	public boolean canRenderFormedStructure()
	{
		return false;
	}
	@Override
	@SideOnly(Side.CLIENT)
	public void renderFormedStructure()
	{
	}

	@Override
	public String getUniqueName()
	{
		return "IE:AlloySmelter";
	}

	@Override
	public boolean isBlockTrigger(IBlockState state)
	{
		return state.func_177230_c()==IEContent.blockStoneDecoration && state.func_177230_c().func_176201_c(state)==BlockTypes_StoneDecoration.ALLOYBRICK.getMeta();
	}

	@Override
	public boolean createStructure(World world, BlockPos pos, EnumFacing side, EntityPlayer player)
	{
		EnumFacing f = EnumFacing.func_176733_a(player.field_70177_z);

		if(Utils.isBlockAt(world, pos.func_177977_b(), IEContent.blockStoneDecoration, BlockTypes_StoneDecoration.ALLOYBRICK.getMeta()))
			pos = pos.func_177977_b();
		if(!Utils.isBlockAt(world, pos.func_177972_a(f.func_176746_e()), IEContent.blockStoneDecoration, BlockTypes_StoneDecoration.ALLOYBRICK.getMeta()))
			pos = pos.func_177972_a(f.func_176735_f());

		for(int h=0;h<=1;h++)
			for(int l=0;l<=1;l++)
				for(int w=0;w<=1;w++)
				{
					BlockPos pos2 = pos.func_177981_b(h).func_177967_a(f,l).func_177967_a(f.func_176746_e(),w);
					if(!Utils.isBlockAt(world, pos2, IEContent.blockStoneDecoration, BlockTypes_StoneDecoration.ALLOYBRICK.getMeta()))
						return false;
				}
		for(int h=0;h<=1;h++)
			for(int l=0;l<=1;l++)
				for(int w=0;w<=1;w++)
				{
					BlockPos pos2 = pos.func_177981_b(h).func_177967_a(f,l).func_177967_a(f.func_176746_e(),w);
					world.func_175656_a(pos2, IEContent.blockStoneDevice.func_176203_a(BlockTypes_StoneDevices.ALLOY_SMELTER.getMeta()));
					TileEntity curr = world.func_175625_s(pos2);
					if(curr instanceof TileEntityAlloySmelter)
					{
						TileEntityAlloySmelter currBlast = (TileEntityAlloySmelter) curr;
						currBlast.offset=new int[]{pos2.func_177958_n()-pos.func_177958_n(),pos2.func_177956_o()-pos.func_177956_o(),pos2.func_177952_p()-pos.func_177952_p()};
						currBlast.pos = (h+1)*9 + (l+1)*3 + (w+1);
						currBlast.facing=f.func_176734_d();
						currBlast.formed=true;
						currBlast.func_70296_d();
						world.func_175641_c(pos2, IEContent.blockStoneDevice, 255, 0);
					}
				}
		return true;
	}

	static final IngredientStack[] materials = new IngredientStack[]{new IngredientStack(new ItemStack(IEContent.blockStoneDecoration, 8, BlockTypes_StoneDecoration.ALLOYBRICK.getMeta()))};
	@Override
	public IngredientStack[] getTotalMaterials()
	{
		return materials;
	}
}
